--TODO: hey do /yell speech bubbles have a RED OUTLINE instead of white? somebody should check

do
	do
		local super=XPRACTICE.GameObject
		XPRACTICE.ANDUIN.BlasphemyDebuffManager=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.BlasphemyDebuffManager
		
		function class:SetCustomInfo()
			super.SetCustomInfo(self)

			self.nextsendindex=1
			self.nextsendtimer=nil
			self.debuffs={}
		end
		
		function class:RandomDebuffs()
			local debuffs={}
			for k,v in pairs(self.scenario.multiplayer.allplayers)do
				local player=v
				if(not (player:IsDeadInGame() or player.dead)) then
					tinsert(debuffs,{guid=player.paddedguid,debuff="X"})
					--print("player?",v,player.paddedguid,player.debuff)
				end
			end
			XPRACTICE.ShuffleList(debuffs)
			local i=1
			if(#debuffs>=2)then
				while(i+1<=#debuffs)do
					debuffs[i].debuff="1"				
					debuffs[i+1].debuff="2"
					i=i+2
				end
			else
				if(#debuffs==1)then
					if(math.random()>0.5)then debuffs[i].debuff="1" else debuffs[i].debuff="2" end					
				else
					-- nobody alive; do nothing
					-- no status text here; it immediately overwrites "_____ started the encounter"
				end
			end
			self.debuffs=debuffs
			self.nextsendtimer=0
		end
		
		function class:ReplayDebuffs()
			local debuffs={}
			for k,v in pairs(self.scenario.multiplayer.allplayers)do
				local player=v
				if(not (player:IsDeadInGame() or player.dead)) then
					tinsert(debuffs,{guid=player.paddedguid,debuff="X"})
				end
			end
			for i=1,#debuffs do
				if(self.scenario.previousguiddebuffs[debuffs[i].guid])then
					debuffs[i].debuff=self.scenario.previousguiddebuffs[debuffs[i].guid]
				end
			end
			self.debuffs=debuffs
			self.nextsendtimer=0
		end		
		
		function class:CustomDebuffs()
			local debuffs={}
			for k,v in pairs(self.scenario.multiplayer.allplayers)do
				local player=v
				if(not (player:IsDeadInGame() or player.dead)) then
					tinsert(debuffs,{guid=player.paddedguid,debuff="X"})
				end
			end
			for i=1,#debuffs do
				if(XPRACTICE_SAVEDATA.ANDUIN.customdebuffs[debuffs[i].guid])then
					debuffs[i].debuff=XPRACTICE_SAVEDATA.ANDUIN.customdebuffs[debuffs[i].guid]
				end
			end
			self.debuffs=debuffs
			self.nextsendtimer=0
		end				
		
		function class:Step(elapsed)
			super.Step(self,elapsed)
			if(self.nextsendtimer)then
				self.nextsendtimer=self.nextsendtimer-elapsed				
				if(self.nextsendtimer<=0)then
					if(XPRACTICE.ANDUIN.Config.DEBUG)then print("It's time to send some debuffs!") end
					local args={}					
					local cmd="CAST_BLASPHEMY"
					if(self.nextsendindex>10)then
						cmd="BLASPHEMY_CONTINUED"
						if(XPRACTICE.ANDUIN.Config.DEBUG)then print("I'm sending BLASPHEMY_CONTINUED.") end
					else
						tinsert(args,self.scenario.pausemode)
						tinsert(args,XPRACTICE_SAVEDATA.ANDUIN.timelimit)
						tinsert(args,XPRACTICE_SAVEDATA.ANDUIN.mythic)
						cmd="CAST_BLASPHEMY"
						if(XPRACTICE.ANDUIN.Config.DEBUG)then print("I'm sending CAST_BLASPHEMY.") end
					end
					if(XPRACTICE.ANDUIN.Config.DEBUG)then print("I'm sending debuffs for players",self.nextsendindex,"through",self.nextsendindex+9)end
					for i=self.nextsendindex,self.nextsendindex+9 do
						local guid="XXXXXXXXXXXXXXXX"
						local debuff="X"
						if(i<=#self.debuffs)then
							guid=self.debuffs[i].guid
							debuff=self.debuffs[i].debuff
							if(XPRACTICE.ANDUIN.Config.DEBUG)then print("I'm sending debuff \""..debuff.."\" to player "..guid) end
						end
						tinsert(args,guid)
						tinsert(args,debuff)
					end
					
					self.scenario.multiplayer:FormatAndSendCustom(cmd,unpack(args))
					
					self.nextsendtimer=.5
					self.nextsendindex=self.nextsendindex+10
					if(XPRACTICE.ANDUIN.Config.DEBUG)then print("Next time, I'll send debuffs starting with player",self.nextsendindex) end
					if(self.nextsendindex>#self.debuffs)then
						if(XPRACTICE.ANDUIN.Config.DEBUG)then print("I've sent all",#self.debuffs,"debuffs.  Time to stop.") end
						self:Die()
					end
				end
			end			
		end			
	end

	do	
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_Blasphemy=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_Blasphemy
		
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="Blasphemy"
			self.icon="interface/icons/ability_priest_focusedwill.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=2.75;self.basechannelduration=nil;self.basechannelticks=nil
		end
				
		function class:StartCastingEffect(spellinstancepointer)	
			local iconsize="20"
			local icon="\124T"..self.icon..":"..iconsize.."\124t"
			local link="\124cffff0000\124Hspell:361989\124h[Blasphemy]\124h\124r"			
			local message=icon.." Anduin begins casting "..link.."!"
			XPRACTICE_RaidBossEmote(message,5.0,true)			
		
			local scenario=spellinstancepointer.castercombat.mob.scenario
			local bre=XPRACTICE.ANDUIN.BlasphemyRingEffect.new()
			bre:Setup(spellinstancepointer.castercombat.mob.environment)
			bre.scenario=scenario
			
			scenario.boss:CreateSpeechBubble("\124cffff3f40".."There is no balance!".."\124r")
			scenario.blasphemyringeffect=bre
		end
				
		function class:CastingAnimationFunction(spellinstancepointer)	
			spellinstancepointer.castercombat.mob.animationmodule:TryOmniSpellcast()
		end
		function class:CompleteCastingAnimationFunction(spellinstancepointer)				
			spellinstancepointer.castercombat.mob.animationmodule:TryCompleteOmniSpellcast()
		end				
				
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario
			local bpe=XPRACTICE.ANDUIN.BlasphemyProjectileEffect.new()
			bpe:Setup(spellinstancepointer.castercombat.mob.environment)
			bpe.scenario=scenario
			scenario.blasphemyprojectileeffect=bpe
			bpe:CreateBolts()
			
		end
	end	
	
	
	
	do	
		local super=XPRACTICE.MultiSolid
		XPRACTICE.ANDUIN.BlasphemyProjectileEffect=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.BlasphemyProjectileEffect
		
		local ARROWSTARTHEIGHT=4
		local ARROWENDHEIGHT=30
		local ARROWSCALE=2
		local ARROWTIME=XPRACTICE.ANDUIN.Config.ProjectileTravelTime
		function class:SetCustomInfo()
			self.alivetime=0
			self.bolts={}
			self.phase=1
		end
		function class:CreateBolts()
			local scenario=self.scenario
			local guiddebuffs=scenario.guiddebuffs
			--print("?")
			local playercount=0
			for k,v in pairs(guiddebuffs)do
				if(v~="X")then
					local player=self.scenario.multiplayer.guidpointers[k]
					if(player)then
						if(not (player.dead or player:IsDeadInGame()))then
							local bolt=self:AddActorByClass(XPRACTICE.ANDUIN.BlasphemyBoltGraphic,scenario.boss.position.x,scenario.boss.position.y,ARROWSTARTHEIGHT,ARROWSCALE,yaw,-math.pi/2)
							bolt.startx=scenario.boss.position.x
							bolt.starty=scenario.boss.position.y
							bolt.debuff=v;bolt.player=player
							tinsert(self.bolts,bolt)
							playercount=playercount+1
						end
					end
				end
			end
			if(playercount==0)then
				--scenario.statuslabel:SetText("(It looks like everyone's dead.  Click ANKH and try again.)",3.0)
				scenario.statuslabel:SetText("(It would seem nobody received a debuff.)",3.0)
			elseif(playercount==1)then				
				--scenario.statuslabel:SetText("(Did we mention this scenario is designed for \124cffffff00multiplayer\124r practice?...)",3.0)				
				scenario.statuslabel:SetText("(It would seem only one player received a debuff.)",3.0)
			elseif(playercount>=2)then
				-- do nothing; save pause/unpause message for orbs appearing
			end
		end
		function class:Step(elapsed)
			self.alivetime=self.alivetime+elapsed
			local scenario=self.scenario
			if(self.phase==1)then
				local ratio=self.alivetime/ARROWTIME
				for i=1,#self.bolts do
					local bolt=self.bolts[i]				
					if(ratio<0)then ratio=0 elseif(ratio>1)then ratio=1 end
					local x=bolt.startx+(bolt.player.position.x-bolt.startx)*ratio
					local y=bolt.starty+(bolt.player.position.y-bolt.starty)*ratio
					local z=ARROWSTARTHEIGHT+(ARROWENDHEIGHT-ARROWSTARTHEIGHT)*math.sin(ratio*math.pi)
					bolt:SetPosition(x/ARROWSCALE,y/ARROWSCALE,z/ARROWSCALE)
					bolt:SetYaw(math.atan2(bolt.player.position.y-bolt.starty,bolt.player.position.x-bolt.startx))
					local distx=(bolt.startx-bolt.player.position.x)
					local disty=(bolt.starty-bolt.player.position.y)
					local dist=math.sqrt(distx*distx+disty*disty)					
					local xyspeed=dist/ARROWTIME
					local zspeed=-math.cos(ratio*math.pi)*(ARROWENDHEIGHT-ARROWSTARTHEIGHT)
					--print(xyspeed,zspeed)
					bolt:SetPitch(math.atan2(zspeed,xyspeed))
				end
				if(ratio>=1)then 
					for i=1,#self.bolts do
						self.bolts[i]:SetAnimation(191)
					end
					scenario.blasphemyringeffect.hiddencolor=false
					scenario.debuffsactive=true
					local boe=XPRACTICE.ANDUIN.BlasphemyOverheadEffect.new()
					boe:Setup(self.environment)
					boe.scenario=scenario
					scenario.blasphemyoverheadeffect=boe
					boe:CreateOverheads()
					
			
					self.phase=2
				end
			elseif(self.phase==2)then
				if(self.alivetime>ARROWTIME+1.0)then
					self:Die()
				end
			end
		end
	end
	
	do
		local super=XPRACTICE.WoWObject
		XPRACTICE.ANDUIN.BlasphemyBoltGraphic=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.BlasphemyBoltGraphic
		function class:SetActorAppearanceViaOwner(actor)
			actor:SetModelByFileID(3707822)	--9fx_generic_anima_maw_missileslowlow (0,144,191)
			actor:SetAnimation(144) --inflight
		end			
	end	
	
	
	do	
		local super=XPRACTICE.MultiSolid
		XPRACTICE.ANDUIN.BlasphemyRingEffect=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.BlasphemyRingEffect
		
		function class:SetCustomInfo()
			self.alivetime=0
			self.rings={}
			self.phase=1
			self.hiddencolor=true
			self.speechtimer=nil
		end
		
		local RINGSCALE=XPRACTICE.ANDUIN.Config.DebuffCollisionRingVisualScale
		
		
		function class:Draw(elapsed)
			super.Draw(self,elapsed)			
			local scenario=self.scenario

			--for k,v in pairs(scenario.guiddebuffs) do
			for k,v in pairs(scenario.multiplayer.allplayers)do
				local guid=v.paddedguid
				local debuff=nil
				if(guid)then debuff=scenario.guiddebuffs[guid] end
				debuff=debuff or "X"
				if(debuff~="X" or (XPRACTICE_SAVEDATA.ANDUIN.mythic==true and XPRACTICE.ANDUIN.Config.ShowMythicCollisionRings==true))then					
					if(not self.rings[guid])then
						local player=v
						local ring
						local class
						if(self.hiddencolor)then
							class=XPRACTICE.ANDUIN.BlasphemyPurpleRing
						elseif(debuff=="1")then
							class=XPRACTICE.ANDUIN.BlasphemyPurpleRing
						elseif(debuff=="2")then
							class=XPRACTICE.ANDUIN.BlasphemyYellowRing
						else
							class=XPRACTICE.ANDUIN.BlasphemyPurpleRing
						end
						ring=self:AddActorByClass(class,player.position.x,player.position.y,0.1,RINGSCALE)
						ring:SetAnimation(0)
						ring.alivetime=0;ring.phase=1
						ring.player=player
						ring.debuff=debuff
						ring.dying=false
						ring.hiddencolor=self.hiddencolor
						self.rings[guid]=ring
					end
					local ring=self.rings[guid]
					ring:SetPosition(ring.player.position.x/RINGSCALE,ring.player.position.y/RINGSCALE,0.1)
					if(ring.phase==1)then
						ring.alivetime=ring.alivetime+elapsed					
						if(ring.alivetime>0.25)then
							ring.phase=2
							ring:SetAnimation(158)
						end
					end
					if(ring.hiddencolor~=self.hiddencolor)then
						ring.hiddencolor=self.hiddencolor					
						if(ring.debuff=="1" or ring.debuff=="X" or ring.debuff==nil)then
							-- do nothing; hidden color is already purple						
						elseif(ring.debuff=="2")then
							ring:SetModelByFileID(1011927)
						end
					end
				end
			end
			for k,v in pairs(self.rings) do				
				local ring=v
				--print(ring.phase,ring.dying,ring.alivetime)
				if(((not scenario.guiddebuffs[k]) or scenario.guiddebuffs[k]=="X")
					and (not (XPRACTICE_SAVEDATA.ANDUIN.mythic==true and XPRACTICE.ANDUIN.Config.ShowMythicCollisionRings==true))
				)then										
					if(not ring.dying)then
						ring.dying=true
						ring.phase=3
						ring.alivetime=0
						ring:SetAnimation(159)
					end
				end
				if(ring.phase==3)then
					ring.alivetime=ring.alivetime+elapsed
					if(ring.alivetime>0.25)then
						ring:ClearModel()
						ring.phase=4
						self.rings[k]=nil
					end
				end
			end
		end
	end
	
	do
		local super=XPRACTICE.WoWObject
		XPRACTICE.ANDUIN.BlasphemyPurpleRing=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.BlasphemyPurpleRing
		function class:SetActorAppearanceViaOwner(actor)
			actor:SetModelByFileID(1040159)	--target_void_state_rimonly (0,158,159)
		end			
		
		--target_sylvanasshadow_state_rimonly
		--target_soul_state_rimonly
		--target_void_state_rimonly 	1040159 (0,158,159)
		--target_holy_state_rimonly		1011927	
		--scale_obj_sphere_ ...		
	end	
	
	do
		local super=XPRACTICE.WoWObject
		XPRACTICE.ANDUIN.BlasphemyYellowRing=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.BlasphemyYellowRing
		function class:SetActorAppearanceViaOwner(actor)
			actor:SetModelByFileID(1011927)	--target_holy_state_rimonly (0,158,159)
		end				
	end		
	
	
	do	
		local super=XPRACTICE.MultiSolid
		XPRACTICE.ANDUIN.BlasphemyOverheadEffect=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.BlasphemyOverheadEffect
		
		function class:SetCustomInfo()
			self.alivetime=3.0	-- start spamming speech bubbles immediately
			self.orbs={}
			self.phase=1
		end
		
		local ORBSCALE=XPRACTICE.ANDUIN.Config.OverheadSphereScale
		local ORBHEIGHT=XPRACTICE.ANDUIN.Config.OverheadSphereHeight

		function class:CreateOverheads()
			local scenario=self.scenario
			local guiddebuffs=scenario.guiddebuffs
			--print("?")
			local playercount=0
			for k,v in pairs(guiddebuffs)do
				if(v~="X")then
					local player=self.scenario.multiplayer.guidpointers[k]
					if(player)then
						if(not (player.dead or player:IsDeadInGame()))then
							local orb=self:AddActorByClass(XPRACTICE.ANDUIN.BlasphemyOrb,player.position.x,player.position.y,player.position.z+ORBHEIGHT,ORBSCALE)
							orb.debuff=v;orb.player=player
							orb.dying=false
							if(orb.debuff=="1")then
								orb:SetSpellVisualKit(77264)								
							elseif(orb.debuff=="2")then								
								--orb:SetSpellVisualKit(77263)
								orb:SetSpellVisualKit(114730)
							end
							self.orbs[k]=orb
							playercount=playercount+1
						end
					end
				end
			end
			if(playercount>=2)then
				if(scenario.pausemode==true)then
					scenario.statuslabel:SetText("Waiting for an officer to unpause the game...",3.0)
				else
					--scenario.statuslabel:SetText("Go!",3.0)
				end
			end
		end		
		
		function class:Step(elapsed)
			self.alivetime=self.alivetime+elapsed
			if(self.alivetime>3.0)then
				--self.alivetime=self.alivetime-3.0
				self.alivetime=self.alivetime-1.0
				if(XPRACTICE.ANDUIN.Config.SimulateWeakauraSpeechBubbles)then
					if(XPRACTICE_SAVEDATA.ANDUIN.mythic==false)then
						for k,v in pairs(self.orbs)do
							local orb=v
							local message
							if(orb.debuff=="1")then
								message="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_3:12\124t" -- PURPLEDIAMOND					
							elseif(orb.debuff=="2")then
								message="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_1:12\124t" -- YELLOWSTAR
							end
							--orb.player:CreateSpeechBubble("\124cffff3f40"..message.."\124r")
							orb.player:CreateSpeechBubble(message)
						end
					else
						for k,v in pairs(self.scenario.multiplayer.allplayers)do
							local debuff="X"
							local guid=v.paddedguid
							if(guid)then debuff=self.scenario.guiddebuffs[guid] end
							if(debuff=="1")then
								message="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_3:12\124t" -- PURPLEDIAMOND					
							elseif(debuff=="2")then
								message="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_1:12\124t" -- YELLOWSTAR
							else
								message="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:12\124t" -- REDX
							end
							if(not v:IsDeadInGame())then
								v:CreateSpeechBubble(message)
							end
						end
					end
				end
			end
		end
		
		function class:Draw(elapsed)			
			local scenario=self.scenario
			local debugcount=0
			for k,v in pairs(self.orbs) do
				debugcount=debugcount+1
				local orb=v
				orb:SetPosition(orb.player.position.x/ORBSCALE,orb.player.position.y/ORBSCALE,(orb.player.position.z+ORBHEIGHT)/ORBSCALE)				
				if((not scenario.guiddebuffs[k]) or scenario.guiddebuffs[k]=="X" or scenario.guiddebuffs[k]==nil)then					
					if(not orb.dying)then
						orb.dying=true
						orb:ClearModel()
						self.orbs[k]=nil
					end
				end
			end
		end
		
	end
	
	do
		local super=XPRACTICE.WoWObject
		XPRACTICE.ANDUIN.BlasphemyOrb=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.BlasphemyOrb
		function class:SetActorAppearanceViaOwner(actor)
			actor:SetModelByFileID(3088290) --scale_obj_sphere_001gray
		end					
	end			
	
	
	do
		local super=XPRACTICE.WoWObject
		XPRACTICE.ANDUIN.HopelessnessClearEffect=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.HopelessnessClearEffect
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.expirytime=self.environment.localtime+0.75
			self.scale=0.75
			self.velocity.z=5
		end
		function class:SetActorAppearanceViaOwner(actor)
			actor:SetModelByFileID(915916) --nova_holy_raid_low
		end					
	end			

	do
		local super=XPRACTICE.WoWObject
		XPRACTICE.ANDUIN.OverconfidenceClearEffect=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.OverconfidenceClearEffect
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.expirytime=self.environment.localtime+0.75
			self.scale=0.75
			self.velocity.z=5
		end
		function class:SetActorAppearanceViaOwner(actor)
			actor:SetModelByFileID(915916) --nova_holy_raid_low
		end					
	end			
	
	do
		local super=XPRACTICE.WoWObject
		XPRACTICE.ANDUIN.DebuffExplosionEffect=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.DebuffExplosionEffect
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.expirytime=self.environment.localtime+1			
		end
		function class:SetActorAppearanceViaOwner(actor)
			actor:SetModelByFileID(4058681) --9fx_generic_anima_maw_nova_knockback
			self.scale=1.5
			--TODO: use 9fx_raid3_anduin_maw_nova instead (9.2 only)
		end					
	end		
	
	
	
	
	
	
	do
		local super=XPRACTICE.GameObject
		XPRACTICE.ANDUIN.BlasphemyDebuffIcon=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.BlasphemyDebuffIcon
		
		function class:Setup(environment,x,y,z)
			super.Setup(self,environment,x,y,z)
			self.focus=nil
			self.tex=nil
		end
		
		function class:CreateDisplayObject()
			self.displayobject=XPRACTICE.ANDUIN.BlasphemyDebuffDisplayObject.new()
			self.displayobject:Setup(self)
		end
		
		
		function class:Step(elapsed)
			super.Step(self,elapsed)
			local player=self.focus		
			if(not player)then self.displayobject.drawable:Hide(); return end
			local guid=player.paddedguid
			if(guid)then
				local scenario=self.scenario
				if(scenario.debuffsactive)then
					if(scenario.guiddebuffs[guid]=="1" or scenario.guiddebuffs[guid]=="2")then
						local targettex="interface/icons/ability_priest_focusedwill.blp"
						if(scenario.guiddebuffs[guid]=="1")then
							targettex="interface/icons/ability_priest_halo_shadow.blp"
						elseif(scenario.guiddebuffs[guid]=="2")then
							targettex="interface/icons/ability_priest_halo.blp"
						end
						self.displayobject.drawable:Show()
						if(self.tex~=targettex)then
							self.displayobject.back.texture:SetTexture(targettex)
							self.tex=targettex
						end						
						local timetext=string.format("%0.1f",scenario.timeelapsed)
						self.displayobject.text.fontstring:SetText(timetext)
					end
				end
				if(not scenario.debuffsactive)then
					self.displayobject.drawable:Hide()
				end
				
				-- if(player)then
					
					-- local auras=player.combatmodule.auras:GetAurasByClassIfExist(XPRACTICE.ANDUIN.Aura_LaserDebuff)
					-- if(#auras>0)then
						-- local aura=auras[1]
						-- self.displayobject.drawable:Show()			
						-- local stacktext=""			
						-- if(aura.expirytime)then
							-- local remaining=math.floor(aura.expirytime-aura.targetcombat.localtime)
							-- stacktext=tostring(remaining)
						-- end
						-- self.displayobject.text.fontstring:SetText(stacktext)
					-- else
						-- self.displayobject.drawable:Hide()
					-- end			
				-- else
					-- self.displayobject.drawable:Hide()
				-- end
			end
		end

		function class:Draw(elapsed)
			--TODO: maybe move this to base class but check for existence of displayobject?
			self.displayobject:SetPositionAndScale(self.position,self.scale)
		end	
		
		
	end
	
	do
		local super=XPRACTICE.DisplayObject
		XPRACTICE.ANDUIN.BlasphemyDebuffDisplayObject=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.BlasphemyDebuffDisplayObject
		
		function class:CreateDrawable()		
			local f=XPRACTICE.ReusableFrames:GetFrame()
			self.drawable=f
			self.drawable.owner=self
			self.back=f
			tinsert(self.drawables,f)
			local f=XPRACTICE.ReusableFrames:GetFrame()
			self.text=f
			tinsert(self.drawables,f)
		end
		function class:SetAppearance()
			--self.parentframe=self.owner.environment.hudframe
			self.parentframe=self.owner.environment.frame
			--self.parentframe=UIParent
			self.back:SetParent(self.parentframe)
			self.back.texture:Show();self.back.texture:SetTexture("interface/icons/ability_priest_focusedwill.blp")
			self.back:Show();self.back:SetAlpha(1)
			self.back:SetSize(100,100)
			self.back:SetFrameLevel(200)				
			
			self.text:Show();self.text:SetAlpha(1)
			self.text:SetParent(self.back)
			--self.text:SetAllPoints(self.icon)
			self.text:SetAllPoints(self.back)
			self.text.fontstring:Show();self.text.fontstring:SetScale(2)
			self.text.fontstring:SetText("")
			self.text:SetFrameLevel(202)
			
		end	
		function class:SetPositionAndScale(position,scale)
			self.back:SetPoint("BOTTOMLEFT",self.parentframe,"BOTTOMLEFT",position.x,position.y)
		end
	
	end
	
end