do
	--TODO: volatile code reuse -- only use function in multiplayer/messagehandler.lua
	local function IsRealOfficer(unit)
		unit=strsplit("-",unit)
		return ((UnitIsGroupLeader(unit)==true) or (UnitIsGroupAssistant(unit)==true) or not IsInGroup(unit))
	end

	do	
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_Brez=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_Brez
		
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Brez)"
			self.icon="interface/icons/inv_jewelry_talisman_06.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
				
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario	
			scenario:Brez()
		end
	end	
	

		
	do	
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_StartEncounter=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_StartEncounter
		
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			--self.name="(Lock)"
			--self.icon="interface/icons/inv_misc_key_15.blp"
			self.name="Blasphemy"
			self.icon="interface/icons/ability_priest_focusedwill.blp"
			--ability_priest_voidshift
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
				
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario					
			if(not IsRealOfficer("player"))then
				scenario.statuslabel:SetText("When you are in a group, you must be lead/assist to start the game.",3.0)
				return 
			end			
			if(scenario.multiplayer.roomlockpending)then 
				--TODO LATER: maybe error message here too?
				return
			end
			if(scenario.multiplayer.roomlocked)then 
				scenario.statuslabel:SetText("Seems to be a game in progress already.",3.0)
				return 
			end			
			local count=0
			for k,v in pairs(self.scenario.multiplayer.allplayers)do
				local player=v
				if(not (player:IsDeadInGame() or player.dead)) then
					count=count+1
				end
			end			
			-- if(count<2)then
				-- scenario.statuslabel:SetText("Need at least two players alive to start.",3.0)
				-- return 			
			-- end
			--scenario.multiplayer:FormatAndSend("LOCKv2")
			scenario.scenariomode=1
			scenario.multiplayer:FormatAndSend("LOCK")
		end
	end	
	
	do	
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_ReplayEncounter=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_ReplayEncounter
		
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			--self.name="(Lock)"
			--self.icon="interface/icons/inv_misc_key_15.blp"
			self.name="Blasphemy (replay)"
			self.icon="interface/icons/ability_priest_voidshift.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
				
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario					
			if(not IsRealOfficer("player"))then
				scenario.statuslabel:SetText("When you are in a group, you must be lead/assist to start the game.",3.0)
				return 
			end			
			if(scenario.multiplayer.roomlockpending)then 
				--TODO LATER: maybe error message here too?
				return
			end
			if(scenario.multiplayer.roomlocked)then 
				scenario.statuslabel:SetText("Seems to be a game in progress already.",3.0)
				return 
			end
			local next=next
			if(next(scenario.previousguiddebuffs)==nil)then
				scenario.statuslabel:SetText("There is nothing to replay.  Click BLASPHEMY first.",3.0)
				return 			
			end
			--scenario.multiplayer:FormatAndSend("LOCKv2")
			scenario.scenariomode=2
			scenario.multiplayer:FormatAndSend("LOCK")
		end
	end				
	
	do	
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_CustomEncounter=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_CustomEncounter
		
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="Blasphemy (custom)"
			self.icon="interface/icons/inv_misc_wrench_01.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
				
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario					
			if(not IsRealOfficer("player"))then
				scenario.statuslabel:SetText("When you are in a group, you must be lead/assist to start the game.",3.0)
				return 
			end			
			if(scenario.multiplayer.roomlockpending)then 
				--TODO LATER: maybe error message here too?
				return
			end
			if(scenario.multiplayer.roomlocked)then 
				scenario.statuslabel:SetText("Seems to be a game in progress already.",3.0)
				return 
			end
			local next=next
			if(next(XPRACTICE_SAVEDATA.ANDUIN.customdebuffs)==nil)then
				scenario.statuslabel:SetText("No custom debuffs have been set.",3.0)
				return 			
			end
			scenario.scenariomode=3		--TODO LATER: race condition: what if host clicks two different start buttons at once?
			scenario.multiplayer:FormatAndSend("LOCK")
		end
	end				
	
	
	do	
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_StopEncounter=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_StopEncounter 
		
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Stop encounter)"
			self.icon="interface/icons/spell_mage_altertime_active.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
				
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario		
			scenario.multiplayer.Send.UNLOCK(scenario.multiplayer)
		end
	end	
	
	
	do	
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_SetDebuff1=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_SetDebuff1
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Set 1)"
			self.icon="interface/icons/ability_iyyokuk_drum_purple.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end		
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario		
			local paddedguid=scenario.multiplayer:GetPaddedUnitGUID("target")
			if(not paddedguid)then
				scenario.statuslabel:SetText("Couldn't find player ID.  Make sure you are \124cffffff00targeting\124r a player in \124cffffff00World of Warcraft\124r.",5.0)
				return
			end
			scenario.statuslabel:SetText("Assigned Hopelessness to "..UnitFullName("target")..".",3.0)
			XPRACTICE_SAVEDATA.ANDUIN.customdebuffs[paddedguid]="1"
		end
	end	
	
	do	
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_SetDebuff2=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_SetDebuff2
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Set 2)"
			self.icon="interface/icons/ability_iyyokuk_drum_yellow.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end		
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario		
			local paddedguid=scenario.multiplayer:GetPaddedUnitGUID("target")
			if(not paddedguid)then
				scenario.statuslabel:SetText("Couldn't find player ID.  Make sure you are \124cffffff00targeting\124r a player in \124cffffff00World of Warcraft\124r.",5.0)
				return
			end
			scenario.statuslabel:SetText("Assigned Overconfidence to "..UnitFullName("target")..".",3.0)
			XPRACTICE_SAVEDATA.ANDUIN.customdebuffs[paddedguid]="2"
		end
	end		
	
	do	
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_ClearDebuff=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_ClearDebuff
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Set 2)"
			self.icon="interface/icons/ability_iyyokuk_drum_red.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end		
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario		
			local paddedguid=scenario.multiplayer:GetPaddedUnitGUID("target")
			if(not paddedguid)then
				scenario.statuslabel:SetText("Couldn't find player ID.  Make sure you are \124cffffff00targeting\124r a player in \124cffffff00World of Warcraft\124r.",5.0)
				return
			end
			scenario.statuslabel:SetText("Removed debuff assignment from "..UnitFullName("target")..".",3.0)
			XPRACTICE_SAVEDATA.ANDUIN.customdebuffs[paddedguid]=nil
		end
	end			
	
	do	
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_ClearAllDebuffs=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_ClearAllDebuffs
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Set 2)"
			self.icon="interface/icons/ability_iyyokuk_bomb_red.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end		
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			XPRACTICE_SAVEDATA.ANDUIN.customdebuffs={}
			local scenario=spellinstancepointer.castercombat.mob.scenario		
			scenario.statuslabel:SetText("Removed debuff assignment from all players.",3.0)
		end
	end			
	
	--
	--timelesscoin
	do
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_Pause=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_Pause
		
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Pause)"
			self.icon="interface/icons/timelesscoin-bloody.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
				
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario		
			if(not IsRealOfficer("player"))then
				scenario.statuslabel:SetText("Doing that in a group requires lead/assist.",3.0)
				return 
			end				
			scenario.multiplayer:FormatAndSendCustom("PAUSE")
		end
	end

	do
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_Unpause=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_Unpause
		
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Unpause)"
			self.icon="interface/icons/timelesscoin.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
				
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario		
			if(not IsRealOfficer("player"))then
				scenario.statuslabel:SetText("Doing that in a group requires lead/assist.",3.0)
				return 
			end				
			scenario.multiplayer:FormatAndSendCustom("UNPAUSE")
		end
	end	
	
	do
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_Fuse6=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_Fuse6
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Fuse6)"
			self.icon="interface/icons/inv_eng_bombslow.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario	
			if(not IsRealOfficer("player"))then
				scenario.statuslabel:SetText("Doing that in a group requires lead/assist.",3.0)
				return 
			end	
			local args={}
			tinsert(args,"6")
			scenario.multiplayer:FormatAndSendCustom("FUSE",unpack(args))
		end
	end		
	do
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_Fuse8=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_Fuse8
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Fuse8)"
			self.icon="interface/icons/inv_eng_bombslow.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario	
			if(not IsRealOfficer("player"))then
				scenario.statuslabel:SetText("Doing that in a group requires lead/assist.",3.0)
				return 
			end				
			local args={}
			tinsert(args,"8")
			scenario.multiplayer:FormatAndSendCustom("FUSE",unpack(args))
		end
	end		
	do
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_Fuse10=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_Fuse10
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Fuse10)"
			self.icon="interface/icons/inv_eng_bombslow.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario	
			if(not IsRealOfficer("player"))then
				scenario.statuslabel:SetText("Doing that in a group requires lead/assist.",3.0)
				return 
			end				
			local args={}
			tinsert(args,"A")
			scenario.multiplayer:FormatAndSendCustom("FUSE",unpack(args))
		end
	end			
	do
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_Fuse12=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_Fuse12
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Fuse12)"
			self.icon="interface/icons/inv_eng_bombslow.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario	
			if(not IsRealOfficer("player"))then
				scenario.statuslabel:SetText("Doing that in a group requires lead/assist.",3.0)
				return 
			end				
			local args={}
			tinsert(args,"C")
			scenario.multiplayer:FormatAndSendCustom("FUSE",unpack(args))
		end
	end		
	do
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_FuseX=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_FuseX
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(FuseX)"
			self.icon="interface/icons/inv_eng_bombsleep.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario	
			if(not IsRealOfficer("player"))then
				scenario.statuslabel:SetText("Doing that in a group requires lead/assist.",3.0)
				return 
			end				
			local args={}
			tinsert(args,"X")
			scenario.multiplayer:FormatAndSendCustom("FUSE",unpack(args))
		end
	end		
	
	do
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_Heroic=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_Heroic
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Heroic)"
			self.icon="interface/icons/inv_misc_bone_skull_02.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario	
			if(not IsRealOfficer("player"))then
				scenario.statuslabel:SetText("Doing that in a group requires lead/assist.",3.0)
				return 
			end			
			if(scenario.multiplayer.roomlocked)then 
				scenario.statuslabel:SetText("Can't adjust that while the game is in progress.",3.0)
				return 
			end
			local args={}
			tinsert(args,false)
			scenario.multiplayer:FormatAndSendCustom("MYTHIC",unpack(args))
		end
	end		

	do
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_Mythic=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Spell_Mythic
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Heroic)"
			self.icon="interface/icons/spell_shadow_skull.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario	
			if(not IsRealOfficer("player"))then
				scenario.statuslabel:SetText("Doing that in a group requires lead/assist.",3.0)
				return 
			end				
			if(scenario.multiplayer.roomlocked)then 
				scenario.statuslabel:SetText("Can't adjust that while the game is in progress.",3.0)
				return 
			end			
			local args={}
			tinsert(args,true)
			scenario.multiplayer:FormatAndSendCustom("MYTHIC",unpack(args))
		end
	end			
	
	do
		local super=XPRACTICE.Spell
		XPRACTICE.ANDUIN.Spell_PallyBubble=XPRACTICE.inheritsFrom(super)
		
		local class=XPRACTICE.ANDUIN.Spell_PallyBubble
			function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Bubble)"
			self.icon="interface/icons/spell_holy_divineshield.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
		
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)		
			-- targetcombat doesn't exist because this is a boss debug button.  use castercombat instead
				-- wait nvm we can't use castercombat because castercombat is spellbunny!
			local player=spellinstancepointer.castercombat.mob.scenario.player
			self.scenario.multiplayer:FormatAndSendCustom("PALLYBUBBLE")
		end
		
	--ghost.animationmodule:TryCompleteOmniSpellcast()	
	end	
	
	do
		local super=XPRACTICE.Aura
		XPRACTICE.ANDUIN.Aura_PallyBubble = XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.Aura_PallyBubble

		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.baseduration=5.0
			self.removeondeadingame=true			
			self.tickdelay=1.0
			self.basetickrate=1.0			
			self.tickcount=0
		end			
		function class:OnApply(localtime)
			super.OnApply(self,localtime)
			local player=self.targetcombat.mob
			player.animationmodule:TryCompleteOmniSpellcast()
			--player:CreateSpeechBubble("IMMUNE")	-- don't need to announce to other players here.  fatescribe was an exception.
			local visual=XPRACTICE.ANDUIN.PallyBubbleVisual.new()
			visual:Setup(player.environment,player.position.x,player.position.y,player.position.z)
			visual.player=player
			self.visual=visual
					
		end

		function class:Tick(ticktime)
			self:OnTick(ticktime,1.0)
			--!!!
			--TODO: move to base aura class
			self.previousticktime=ticktime
		end		
		function class:OnTick(ticktime,percentage)
			self.tickcount=self.tickcount+1
			if(self.tickcount>=2 and self.tickcount<=4)then
				local timer=5-self.tickcount
				if(self.targetcombat.mob.scenario)then
					if(self.targetcombat.mob==self.targetcombat.mob.scenario.player)then
							-- (no speech bubbles here, blasphemy debuff comes with its own speech bubble.)
						--self.targetcombat.mob:CreateSpeechBubble(tostring(timer)) 
					end
				end
			end
		end
	end
	
	do
		local super=XPRACTICE.WoWObject
		XPRACTICE.ANDUIN.PallyBubbleVisual=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.ANDUIN.PallyBubbleVisual
		function class:SetActorAppearanceViaOwner(actor)
			actor:SetModelByFileID(1127086)	--cfx_paladin_divineshield_statebase
			self.scale=1.5
		end
		function class:SetDefaultAnimation()
			self.animationmodule:PlayAnimation(XPRACTICE.AnimationList.ProjectileSpawnCustomDuration)
			self.projectilespawncustomduration=0.5
			self.projectileloopcustomduration=4.0
			self.projectiledespawncustomduration=2.0
		end	
		function class:Step(elapsed)
			super.Step(self,elapsed)
			self.position.x=self.player.position.x
			self.position.y=self.player.position.y
			self.position.z=self.player.position.z
			if(self.player:IsDeadInGame())then
				if(not self.toolate)then
					self.toolate=true
					self.animationmodule:PlayAnimation(XPRACTICE.AnimationList.ProjectileDespawnCustomDuration)
				end
			end
		end
	end	
	
	
	

end