do
	--TODO: generic collision base class?
	XPRACTICE.RYGELONARENA.Collision = {}
	local class=XPRACTICE.RYGELONARENA.Collision
	class.__index = class

	function class.new(scenario)
		local self=setmetatable({}, class)
		self.scenario=scenario
		return self 
	end


	function class:OutOfBoundsCheck()
		local scenario=self.scenario
		if(not scenario.player)then return end

		if(scenario.player.position.z<-20)then
			if(not scenario.player:IsDeadInGame())then
				-- pally bubble can't save you here
				scenario:AttemptKillPlayer(scenario.player,true)
				scenario.statuslabel:SetText("Fell off the arena.",3.0)
				local args={}
				tinsert(args,scenario.timeelapsed)
				scenario.multiplayer:FormatAndSendCustom("DEAD_RINGOUT",unpack(args))	
				local player=scenario.player
				player.position.x=-15
				player.position.y=0
				player.position.z=2				
			end
		end
	
		for k,v in pairs(scenario.multiplayer.allplayers)do
			local player=v
			if(player~=scenario.player)then
				if(player.position.z<-20)then
					player.position.x=-15
					player.position.y=0
					player.position.z=2
				end
			end
		end
		
	end
	

	function class:EdgeCheck(player)
		--if(true)then return true end
	
		---------------------------------------------------------------
		--OUT OF BOUNDS CHECK
		---------------------------------------------------------------
		if(true)then return true end --!!!
		
		if(not player)then return true end
		
		local distsqr=player.position.x*player.position.x+player.position.y*player.position.y
		local dist=math.sqrt(distsqr)
		--print("Player dist:",dist)
		local maxradius=41
		if(dist>maxradius)then
			return false
		end			
	
		return true
	end
	
	
	local function CheckCircleCollision(scenario,player)
		for j=1,#scenario.circles do
			local circle=scenario.circles[j]
			local distx=player.position.x-circle.debugx
			local disty=player.position.y-circle.debugy
			local distsqr=distx*distx+disty*disty
			if(distsqr<=2.75*2.75)then
				circle.soakstatus=true
				j=#scenario.circles+1
			end
		end		
	end	
	
	function class:CircleCheck()
		local scenario=self.scenario
		for i=1,#scenario.circles do
			scenario.circles[i].soakstatus=false
		end
		for k,v in pairs(scenario.multiplayer.allplayers) do
			CheckCircleCollision(scenario,v)
		end
	end

	
end