do
	--TODO: volatile code reuse -- only use function in multiplayer/messagehandler.lua
	local function IsRealOfficer(unit)
		unit=strsplit("-",unit)
		return ((UnitIsGroupLeader(unit)==true) or (UnitIsGroupAssistant(unit)==true) or not IsInGroup(unit))
	end

	do	
		local super=XPRACTICE.Spell
		XPRACTICE.RYGELONARENA.Spell_Brez=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.RYGELONARENA.Spell_Brez
		
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Brez)"
			self.icon="interface/icons/inv_jewelry_talisman_06.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
				
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario	
			scenario:Brez()
		end
	end	
	
	
	do
		local super=XPRACTICE.Spell
		XPRACTICE.RYGELONARENA.Spell_PallyBubble=XPRACTICE.inheritsFrom(super)
		
		local class=XPRACTICE.RYGELONARENA.Spell_PallyBubble
			function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="(Bubble)"
			self.icon="interface/icons/spell_holy_divineshield.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
		
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)		
			-- targetcombat doesn't exist because this is a boss debug button.  use castercombat instead
				-- wait nvm we can't use castercombat because castercombat is spellbunny!
			local player=spellinstancepointer.castercombat.mob.scenario.player
			self.scenario.multiplayer:FormatAndSendCustom("PALLYBUBBLE")
		end
		
	--ghost.animationmodule:TryCompleteOmniSpellcast()	
	end	
	
	do
		local super=XPRACTICE.Aura
		XPRACTICE.RYGELONARENA.Aura_PallyBubble = XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.RYGELONARENA.Aura_PallyBubble

		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.baseduration=5.0
			self.removeondeadingame=true			
			self.tickdelay=1.0
			self.basetickrate=1.0			
			self.tickcount=0
		end			
		function class:OnApply(localtime)
			super.OnApply(self,localtime)
			local player=self.targetcombat.mob
			player.animationmodule:TryCompleteOmniSpellcast()
			--player:CreateSpeechBubble("IMMUNE")	-- don't need to announce to other players here.  fatescribe was an exception.
			local visual=XPRACTICE.RYGELONARENA.PallyBubbleVisual.new()
			visual:Setup(player.environment,player.position.x,player.position.y,player.position.z)
			visual.player=player
			self.visual=visual
					
		end

		function class:Tick(ticktime)
			self:OnTick(ticktime,1.0)
			--!!!
			--TODO: move to base aura class
			self.previousticktime=ticktime
		end		
		function class:OnTick(ticktime,percentage)
			self.tickcount=self.tickcount+1
			if(self.tickcount>=2 and self.tickcount<=4)then
				local timer=5-self.tickcount
				if(self.targetcombat.mob.scenario)then
					if(self.targetcombat.mob==self.targetcombat.mob.scenario.player)then
							-- (no speech bubbles here, blasphemy debuff comes with its own speech bubble.)
						--self.targetcombat.mob:CreateSpeechBubble(tostring(timer)) 
					end
				end
			end
		end
	end
	
	do
		local super=XPRACTICE.WoWObject
		XPRACTICE.RYGELONARENA.PallyBubbleVisual=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.RYGELONARENA.PallyBubbleVisual
		function class:SetActorAppearanceViaOwner(actor)
			actor:SetModelByFileID(1127086)	--cfx_paladin_divineshield_statebase
			self.scale=1.5
		end
		function class:SetDefaultAnimation()
			self.animationmodule:PlayAnimation(XPRACTICE.AnimationList.ProjectileSpawnCustomDuration)
			self.projectilespawncustomduration=0.5
			self.projectileloopcustomduration=4.0
			self.projectiledespawncustomduration=2.0
		end	
		function class:Step(elapsed)
			super.Step(self,elapsed)
			self.position.x=self.player.position.x
			self.position.y=self.player.position.y
			self.position.z=self.player.position.z
			if(self.player:IsDeadInGame())then
				if(not self.toolate)then
					self.toolate=true
					self.animationmodule:PlayAnimation(XPRACTICE.AnimationList.ProjectileDespawnCustomDuration)
				end
			end
		end
	end	
	
	
	do	
		local super=XPRACTICE.Spell
		XPRACTICE.RYGELONARENA.Spell_AddCircle=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.RYGELONARENA.Spell_AddCircle
		
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="()"
			self.icon="interface/icons/inv_misc_questionmark.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
				
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario	
			local player=scenario.player
			XPRACTICE.RYGELONARENA.AddCircle(scenario,player.position.x,player.position.y)
		end
	end		
	
	--TODO: not global function, maybe
	function XPRACTICE.RYGELONARENA.AddCircle(scenario,x,y)
		local circle=XPRACTICE.RYGELONARENA.IntermissionCircle.new()
		circle:Setup(scenario.game.environment_gameplay,x,y,0)
		circle.debugx=x
		circle.debugy=y
		tinsert(scenario.circles,circle)
	end
	
	
	do	
		local super=XPRACTICE.Spell
		XPRACTICE.RYGELONARENA.Spell_ReportCircle=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.RYGELONARENA.Spell_ReportCircle
		
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="()"
			self.icon="interface/icons/inv_misc_questionmark.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
				
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario	
			local player=scenario.player
			local mindist=nil
			local nearestcircle=nil
			for i=1,#scenario.circles do
				local circle=scenario.circles[i]
				local dist=math.sqrt((circle.debugx-player.position.x)*(circle.debugx-player.position.x)+(circle.debugy-player.position.y)*(circle.debugy-player.position.y))
				if(dist<4.0)then
					if((not mindist) or dist<mindist)then
						mindist=dist
						nearestcircle=circle
					end
				end
			end
			if(nearestcircle)then
				print("Circle:",nearestcircle.debugx,nearestcircle.debugy)
			else
				print("Not found")
			end
		end
	end		
	
	do	
		local super=XPRACTICE.Spell
		XPRACTICE.RYGELONARENA.Spell_MoveCircle=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.RYGELONARENA.Spell_MoveCircle
		
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="()"
			self.icon="interface/icons/inv_misc_questionmark.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
				
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario	
			local player=scenario.player
			local mindist=nil
			local nearestcircle=nil
			local nearestindex=nil
			for i=1,#scenario.circles do
				local circle=scenario.circles[i]
				local dist=math.sqrt((circle.debugx-player.position.x)*(circle.debugx-player.position.x)+(circle.debugy-player.position.y)*(circle.debugy-player.position.y))
				if(dist<4.0)then
					if((not mindist) or dist<mindist)then
						mindist=dist
						nearestcircle=circle
						nearestindex=i
					end
				end
			end
			if(nearestcircle)then
				nearestcircle:Die()
				tremove(scenario.circles,nearestindex)
				XPRACTICE.RYGELONARENA.AddCircle(scenario,player.position.x,player.position.y)
			end
		end
	end		
			
	do	
		local super=XPRACTICE.Spell
		XPRACTICE.RYGELONARENA.Spell_CallToArms=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.RYGELONARENA.Spell_CallToArms
		
		function class:SetCustomInfo()
			super.SetCustomInfo(self)
			self.name="()"
			self.icon="interface/icons/ability_hunter_beastcall.blp"
			self.requiresfacing=false;self.projectileclass=nil;self.basecastduration=0.0;self.basechannelduration=nil;self.basechannelticks=nil
		end
				
		function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
			local scenario=spellinstancepointer.castercombat.mob.scenario	
			
			if(not XPRACTICE.MULTIPLAYERV2.IsRealOfficer("player"))then
				self.scenario.statuslabel:SetText("Only raid officers are allowed to use the CALL button.",3.0)
				return
			end
			if(GetNumGroupMembers()<=1)then
				self.scenario.statuslabel:SetText("There are no other players to call!  Create a group first.",3.0)
				return
			end
				

			if((not scenario.tempmenu.currentmenu) or scenario.tempmenu.currentmenu.menuclass~=XPRACTICE.CallToArmsInterface)then
				scenario.tempmenu:LoadMenu(XPRACTICE.CallToArmsInterface)
				scenario.tempmenu.currentmenu.extradata="CALL_TO_ARMS JOIN RYGELON 1"
			else
				scenario.tempmenu:UnloadCurrentMenu()
			end			
				
		end
	end		

		
	

end