do
	local super=XPRACTICE.GameObject
	XPRACTICE.THEJAILER2.ExplosiveRunes_AuraTracker=XPRACTICE.inheritsFrom(super)
	local class=XPRACTICE.THEJAILER2.ExplosiveRunes_AuraTracker
	
	function class:CreateDisplayObject()
		self.displayobject=XPRACTICE.THEJAILER2.ExplosiveRunes_AuraTrackerDisplayObject.new()
		self.displayobject:Setup(self)
		self.prevhole=nil
	end
	
	function class:Draw(elapsed)
		--TODO: maybe move this to base class but check for existence of displayobject?
		self.displayobject:SetPositionAndScale(self.position,self.scale)
	end		
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		local player=self.scenario.player
		if(player)then
			local auras=player.combatmodule.auras:GetAurasByClassIfExist(XPRACTICE.THEJAILER2.Aura_ExplosiveRunes)
			if(#auras>0)then				
				local aura=auras[1]
				self.displayobject.drawable:Show()				
				if(auras[1].hole~=self.prevhole)then
					self.displayobject.text.fontstring:SetText(auras[1].hole)	
					for k,v in pairs(self.displayobject.points) do
						local point=v
						if(k==auras[1].hole)then
							if(XPRACTICE.TOCVersion>=100000)then
								point.texture:SetGradient("HORIZONTAL",XPRACTICE.Colors.SolidGreen,XPRACTICE.Colors.SolidGreen)
							else
								point.texture:SetGradientAlpha("HORIZONTAL",0,1,0,1,0,1,0,1);   --pre-100002
							end
						else
							if(XPRACTICE.TOCVersion>=100000)then
								point.texture:SetGradient("HORIZONTAL",XPRACTICE.Colors.SolidDarkGray,XPRACTICE.Colors.SolidDarkGray)
							else
								point.texture:SetGradientAlpha("HORIZONTAL",0.125,0.125,0.125,1,0.125,0.125,0.125,1);   --pre-100002
							end
						end
					end
					self.prevhole=auras[1].hole
				end
				self.displayobject.timercircle:Show()
				self.displayobject.timertext:Show()
				local timeuntiljump=aura.expirytime-player.environment.localtime-1.25

				local timetext=string.format("%0.1f",timeuntiljump)
				if(timeuntiljump>0)then
					timetext="WAIT\n"..timetext
					if(XPRACTICE.TOCVersion>=100000)then
						self.displayobject.timercircle.texture:SetGradient("HORIZONTAL",XPRACTICE.Colors.TranslucentGreen,XPRACTICE.Colors.TranslucentGreen)						
					else
						self.displayobject.timercircle.texture:SetGradientAlpha("HORIZONTAL",0.0,1.0,0.0,0.5,0.0,1.0,0.0,0.5)   --pre-100002						
					end
				else
					timetext="JUMP"
					if(XPRACTICE.TOCVersion>=100000)then
						self.displayobject.timercircle.texture:SetGradient("HORIZONTAL",XPRACTICE.Colors.TranslucentRed,XPRACTICE.Colors.TranslucentRed)
					else
						self.displayobject.timercircle.texture:SetGradientAlpha("HORIZONTAL",1.0,0.0,0.0,0.5,1.0,0.0,0.0,0.5)   --pre-100002
					end
				end
				self.displayobject.timertext.fontstring:SetText(timetext)
			else
				self.displayobject.drawable:Hide()
				self.displayobject.timercircle:Hide()
				self.displayobject.timertext:Hide()				
			end						
		else
			self.displayobject.drawable:Hide()
			self.displayobject.timercircle:Hide()
			self.displayobject.timertext:Hide()					
		end
	end
	
end
	
do
	local super=XPRACTICE.DisplayObject
	XPRACTICE.THEJAILER2.ExplosiveRunes_AuraTrackerDisplayObject=XPRACTICE.inheritsFrom(super)
	local class=XPRACTICE.THEJAILER2.ExplosiveRunes_AuraTrackerDisplayObject
	
	function class:CreateDrawable()		
		local f=XPRACTICE.ReusableFrames:GetFrame()
		self.drawable=f
		self.drawable.owner=self
		self.back=f
		tinsert(self.drawables,f)
		
		local f=XPRACTICE.ReusableFrames:GetFrame()
		self.text=f
		tinsert(self.drawables,f)
		
		self.points={}
		local f=XPRACTICE.ReusableFrames:GetFrame()
		self.points["FRONT"]=f
		tinsert(self.drawables,f)
		local f=XPRACTICE.ReusableFrames:GetFrame()
		self.points["MID LEFT"]=f
		tinsert(self.drawables,f)
		local f=XPRACTICE.ReusableFrames:GetFrame()
		self.points["MID RIGHT"]=f
		tinsert(self.drawables,f)
		local f=XPRACTICE.ReusableFrames:GetFrame()
		self.points["BACK LEFT"]=f
		tinsert(self.drawables,f)
		local f=XPRACTICE.ReusableFrames:GetFrame()
		self.points["BACK CENTER"]=f
		tinsert(self.drawables,f)
		local f=XPRACTICE.ReusableFrames:GetFrame()
		self.points["BACK RIGHT"]=f
		tinsert(self.drawables,f)		
		
		local f=XPRACTICE.ReusableFrames:GetFrame()
		self.timercircle=f
		tinsert(self.drawables,f)
		local f=XPRACTICE.ReusableFrames:GetFrame()
		self.timertext=f
		tinsert(self.drawables,f)	
	end	
	
	function class:SetAppearance()
		--self.parentframe=self.owner.environment.hudframe
		self.parentframe=self.owner.environment.frame
		--self.parentframe=UIParent
		self.back:SetParent(self.parentframe)
		self.back:SetSize(200,200)
		self.back:SetFrameLevel(200)				
		--TODO: change folders
		self.back.texture:SetTexture("interface/addons/xpractice/content/wow/thejailer/assets/rightedge.tga")						
		self.back.texture:Show()
		self.back:Show();self.back:SetAlpha(1)		

		self.text:Show();self.text:SetAlpha(1)
		self.text:SetParent(self.back)
		--self.text:SetAllPoints(self.icon)
		--self.text:SetAllPoints(self.back)
		self.text:SetPoint("TOP",self.back,"BOTTOM",0,15)
		self.text:SetWidth(500)
		self.text:SetHeight(100)
		self.text.fontstring:Show();self.text.fontstring:SetScale(2)
		self.text.fontstring:SetText("")
		self.text:SetFrameLevel(202)
		
		for k,v in pairs(self.points) do
			local point=v
			point:Show();point:SetAlpha(1)
			point:SetParent(self.back)
			point:SetSize(50,50)
			point:SetFrameLevel(202)
			point:SetPoint("CENTER",self.back,"CENTER",0,0)
			--TODO: change folders
			point.texture:SetTexture("interface/addons/xpractice/content/wow/thejailer/assets/circle.tga")						
			--point.texture:SetTexture("interface/addons/xpractice/content/wow/thejailer/assets/rightedge.tga")						
			point.texture:Show()
			if(XPRACTICE.TOCVersion>=100000)then
				point.texture:SetGradient("HORIZONTAL",XPRACTICE.Colors.SolidDarkGray,XPRACTICE.Colors.SolidDarkGray)
			else
				point.texture:SetGradientAlpha("HORIZONTAL",0.125,0.125,0.125,1,0.125,0.125,0.125,1);   --pre-100002
			end
			point:Show();self.back:SetAlpha(1)	
		-- point.fontstring:Show();point:SetScale(2)
		-- point.fontstring:SetText("!!")
		-- point:SetFrameLevel(202)			
		end
		local side=180
		self.points["FRONT"]:SetPoint("CENTER",self.back,"CENTER",0,side/2*math.sqrt(3)/2)
		self.points["BACK RIGHT"]:SetPoint("CENTER",self.back,"CENTER",side/2,-side/2*math.sqrt(3)/2)
		self.points["BACK CENTER"]:SetPoint("CENTER",self.back,"CENTER",0,-side/2*math.sqrt(3)/2)
		self.points["BACK LEFT"]:SetPoint("CENTER",self.back,"CENTER",-side/2,-side/2*math.sqrt(3)/2)
		self.points["MID LEFT"]:SetPoint("CENTER",self.back,"CENTER",-side/4,0)
		self.points["MID RIGHT"]:SetPoint("CENTER",self.back,"CENTER",side/4,0)
		
		self.timercircle:Show();self.timercircle:SetAlpha(1)
		self.timercircle:SetParent(self.owner.environment.frame)
		self.timercircle.texture:SetTexture("interface/addons/xpractice/content/wow/thejailer/assets/circle.tga")						
		self.timercircle.texture:Show()
		if(XPRACTICE.TOCVersion>=100000)then
			self.timercircle.texture:SetGradient("HORIZONTAL",XPRACTICE.Colors.TranslucentGreen,XPRACTICE.Colors.TranslucentGreen)
		else
			self.timercircle.texture:SetGradientAlpha("HORIZONTAL",0.0,1.0,0.0,0.5,0.0,1.0,0.0,0.5)   --pre-100002
		end
		self.timercircle:SetPoint("CENTER",self.owner.environment.frame,"CENTER",0,-75)
		self.timercircle:SetSize(75,75)
		self.timercircle:SetFrameLevel(201)
		self.timercircle:Hide()
		
		self.timertext:Show();self.timertext:SetAlpha(1)
		self.timertext:SetParent(self.owner.environment.frame)
		--self.timertext:SetAllPoints(self.icon)
		--self.timertext:SetAllPoints(self.back)
		self.timertext:SetPoint("CENTER",self.owner.environment.frame,"CENTER",0,-75)
		self.timertext:SetWidth(500)
		self.timertext:SetHeight(100)
		self.timertext.fontstring:Show();self.timertext.fontstring:SetScale(1.5)
		self.timertext.fontstring:SetText("WAIT\n3.0")
		self.timertext:SetFrameLevel(202)
		self.timertext:Hide()
		
	end		
	function class:SetPositionAndScale(position,scale)
		self.back:SetPoint("BOTTOMLEFT",self.parentframe,"BOTTOMLEFT",position.x,position.y)
	end

	
end